#include "StrateIsolante.h"
#include "GestionnaireSockets.h"
#include "zone_transit.h"
#include "SimpleStoppeur.h"
#include <string>
using std::string;

class SocketClientSimple
   : public SimpleStoppeur
{
   zone_transit a_envoyer_;
   socket_t socket_;
   string texte_a_envoyer_;
public:
   SocketClientSimple
      (const string &adresse, const short port_denormalise)
   :
      socket_(creer_socket())
   {
      connecter(socket_, adresse, htons(port_denormalise));
   }
   void fermer() throw()
   {
      if (!est_invalide(socket_))
      {
         fermer_socket(socket_);
         invalider_socket(socket_);
      }
   }
   ~SocketClientSimple() throw()
      { fermer(); }
   void ajouter_texte(const string &texte) volatile
      { a_envoyer_.ajouter(texte); }
   void envoyer() volatile
   {
      string &s = const_cast<string &>(texte_a_envoyer_);
      s += a_envoyer_.extraire();
      if (!s.empty())
      {
         int n = send(socket_, s.c_str(), static_cast<int>(s.size()), 0);
         if (est_erreur(n))
            demander_arret();
         else
            s = s.substr(n);
      }
   }
   string recevoir() volatile
   {
      const int TAILLE_TAMPON = 64; // taille arbitraire
      char tampon[TAILLE_TAMPON];
      int n = recv(socket_, tampon, TAILLE_TAMPON, 0);
      string s;
      if (est_erreur(n))
         demander_arret();
      else
         s = string(tampon, tampon + n);
      return s;
   }
};

#include <algorithm>
using std::for_each;
#include <iostream>
using std::cout;
using std::cin;
using std::endl;
#include <conio.h>
#include <windows.h>

unsigned long __stdcall Envoyer     (void*);
unsigned long __stdcall LireClavier (void*);
unsigned long __stdcall Recevoir    (void*);

int main ()
{
   const string IP_SERVEUR = "127.0.0.1"; // le loopback; choix arbitraire
   const short PORT_SERVEUR = 4433;

   SocketClientSimple ssmp(IP_SERVEUR, PORT_SERVEUR);
   cout << "Connecte! Entrez chaque ligne a envoyer ('.' pour terminer)" << endl;

   HANDLE hTh[] =
   {
      CreateThread(0, 0, Envoyer, &ssmp, 0, 0),
      CreateThread(0, 0, LireClavier, &ssmp, 0, 0),
      CreateThread(0, 0, Recevoir, &ssmp, 0, 0)
   };
   enum { N = sizeof(hTh) / sizeof(hTh[0]) };
   WaitForMultipleObjects(N, hTh, TRUE, INFINITE);
   for_each(hTh, hTh+ N, CloseHandle);
}

unsigned long __stdcall Envoyer  (void *p)
{
   SocketClientSimple *ssmp = reinterpret_cast<SocketClientSimple *> (p);
   while (!ssmp->arret_demande())
   {
      ssmp->envoyer();
      Sleep(10);
   }  
   ssmp->arret_complete();
   return 0;
}


unsigned long __stdcall LireClavier (void *p)
{
   SocketClientSimple *ssmp = reinterpret_cast<SocketClientSimple*>(p);
   const string TEXTE_FIN = ".";
   string texte;
   while (getline(cin, texte) && !ssmp->arret_demande())
      if (!texte.empty() && texte != TEXTE_FIN)
         ssmp->ajouter_texte(texte);
      else
         ssmp->demander_arret();
   // au cas...
   ssmp->demander_arret();
   // Violent, mais efficace
   ssmp->fermer();
   ssmp->arret_complete();
   return 0UL;
}


unsigned long __stdcall Recevoir(void *p)
{
   SocketClientSimple *ssmp = reinterpret_cast<SocketClientSimple*>(p);
   while (!ssmp->arret_demande())
      cout << ssmp->recevoir() << endl;;
   ssmp->arret_complete();
   return 0UL;
}
