#ifndef MUTEX_H
#define MUTEX_H

#include "Incopiable.h"
#include <windows.h> // non portable; on peut faire mieux

class Mutex
   : Incopiable
{
   HANDLE h_;
public:
   Mutex()
      : h_(CreateMutex(0, FALSE, 0))
   {
   }
   ~Mutex() throw()
      { CloseHandle(h_); }
   void obtenir() const volatile throw()
      { WaitForSingleObject(h_, INFINITE); }
   void relacher() const volatile throw()
      { ReleaseMutex(h_); }
};

class Autoverrou
   : Incopiable
{
   const volatile Mutex &m_;
public:
   Autoverrou(const volatile Mutex &m)
      : m_(m)
   {
      m_.obtenir();
   }
   ~Autoverrou() throw()
      { m_.relacher(); }
};

#endif
